@setlocal
@REM a test build sceneario ...
@set TEMPRET=%CD%
@set TEMPFIL=%TEMP%\tempfil.txt
@set TEMPDBG=pause
@set TEMPDBG=echo.

@REM WORK TOOLS NEEDED
@set TEMPX1=%TEMPRET%\bin\raw2ascii.exe
@set TEMPX2=%TEMPRET%\bin\demchop.exe
@set TEMPX3=%TEMPRET%\bin\terrafit.exe
@set TEMPX4=%TEMPRET%\bin\genapts.exe
@set TEMPX5=%TEMPRET%\bin\tgvpf.exe
@set TEMPX6=%TEMPRET%\bin\fgfs-construct.exe

@REM OTHER TOOLS NEEDED
@set TEMPGZIP=gzip
@set TEMPGZIPH=-h
@set TEMPGZIPD=-dv
@set TEMPTAR=tar
@set TEMPTARH=--help
@set TEMPTARX=-xvf

@REM RAW2ASCII LIMITS
@set TEMPMILON=150
@set TEMPMXLON=154
@set TEMPMILAT=-37
@set TEMPMXLAT=-30
@set TEMPRANGE=--min-lon=%TEMPMILON% --max-lon=%TEMPMXLON% --min-lat=%TEMPMILAT% --max-lat=%TEMPMXLAT%
@REM Constuct requires a width
@set TEMPX=4
@set TEMPY=7
@set TEMPCHUNK=e150s40
@set TEMPCRNG=--lon=%TEMPMXLON% --lat=%TEMPMXLAT% --xdist=%TEMPX% --ydist=%TEMPY%

@REM FILES NEEDED OR CREATED ALONG THE WAY
@set TEMPAPT=apt.dat
@set TEMPAPT1=..\..\..\data\Airports\%TEMPAPT%
@set TEMPAPT2=%TEMPAPT%.gz
@set TEMPAPT3=%TEMPAPT1%.gz
@set TEMPVMAP=c:\FG\data\vmap0\v0sas\vmaplv0
@set TEMPVM1=sasaus
@set TEMPVM2=Railroads
@set TEMPVML=LandMass Cities Towns Crops Forest Freeways Roads Railroads Lakes PolarIce Rivers
@set TEMPF1=e140s10.tar
@set TEMPF2=%TEMPF1%.gz
@set TEMPF3=E140S10
@set TEMPF3D=%TEMPF3%.DEM
@set TEMPF3H=%TEMPF3%.HDR
@set TEMPF3A=e150s30
@set TEMPF3R=%TEMPF3A%.dem

@REM DIRECTORY STRUCTURE
@set TEMPD=test
@set TEMPD1=data
@set TEMPD2=DEMRAW
@set TEMPD3=DEMASCII
@set TEMPW1=work
@REM This HAS to be a directory name in work SEARCHED by genapts - see source for list
@set TEMPW2=SRTM-3
@set TEMPW3=AirportArea
@set TEMPW4=AirportObj
@set TEMPS1=Scenery
@set TEMPS2=Terrain
@set TEMPOUT=%TEMPS1%\%TEMPS2%
@set TEMPDIR=%TEMPVM2%\%TEMPCHUNK%

@echo Running in %TEMPRET%
@echo This is a test build of parts of CHUNK %TEMPCHUNK% ... Sydney, NSW, Australia...
@echo It uses the terragear tools, assumed to be in the 'bin' folder...
@echo.
@echo It requires -
@echo  A: Download of Elevation data -
@echo  B: Base FlightGear Data - at least apt.dat.gz
@echo  C: Download of Land Use Data
@echo.
@echo Where possibly this has been automated, but the batch file has as least one
@echo manual only steps. At that time it will explain what needs to be done,
@echo and pause until you complete the task. It is the download of some elevation data.
@echo.
@echo Be aware that most scenery tools when working output a myriad of lines of data.
@echo These scroll by very rapidly. You would need to redirect the output, if you
@echo wanted to review this information...
@echo.
@echo Checking for some things to continue... maybe fix batch file if fault found...
@echo You MUST also have a number of tools available in your PATH, like
@echo.
@echo Testing 'gzip'...
@echo.
@%TEMPGZIP% %TEMPGZIPH% > %TEMPFIL% 2>&1
@if ERRORLEVEL 1 goto NOTGZIP
@echo Appear to have found a functional gzip...
@echo Testing 'tar'...
@echo.
@%TEMPTAR% %TEMPTARH% > %TEMPFIL% 2>&1
@if ERRORLEVEL 1 goto NOTTAR
@echo Appear to have found a functional tar...
@echo Checking for airport data ...
@if NOT EXIST %TEMPAPT3% goto NOAPT
@echo For some terragear tools (EXES)...
@if NOT EXIST %TEMPX1% goto NOX1
@if NOT EXIST %TEMPX2% goto NOX2
@if NOT EXIST %TEMPX3% goto NOX3
@if NOT EXIST %TEMPX4% goto NOX4
@if NOT EXIST %TEMPX5% goto NOX5
@if NOT EXIST %TEMPX6% goto NOX6
@echo Checking for VMAP0 data...
@if NOT EXIST %TEMPVMAP%\. goto NOVMAP
@if NOT EXIST %TEMPVMAP%\%TEMPVM1%\lht goto NOVMAP
@echo.
@echo *** CONGRATUALTIONS! *** All appears in order, as best as can be done in a batch file..
@echo Are you SURE you want to continue? Ctrl+C to abort.
@pause
@echo.
@REM echo *** ARE YOU REALLY SURE ***
@REM pause

@if NOT EXIST %TEMPD%\. mkdir %TEMPD%
@if NOT EXIST %TEMPD%\. goto ERR1

@cd %TEMPD%

@if NOT EXIST %TEMPD1%\. mkdir %TEMPD1%
@if NOT EXIST %TEMPD1%\. goto ERR2

@cd %TEMPD1%

@if NOT EXIST %TEMPD2%\. mkdir %TEMPD2%
@if NOT EXIST %TEMPD2%\. goto ERR3

@cd %TEMPD2%

@if NOT EXIST %TEMPF3D% goto DODOWN
@if EXIST %TEMPF3H% goto GOTDEMRAW

:DODOWN
@REM http://edcftp.cr.usgs.gov/pub/data/gtopo30/global/e140s10.tar.gz
@if EXIST %TEMPF1% goto GOTTAR
@if EXIST %TEMPF2% goto GOTTARZ
@echo Will being doing a donwload using the browser...
@echo REMEMBER: SAVE the file %TEMPF2% into the following folder only
@echo %CD%...
@echo Then back here to continue...
@start http://edcftp.cr.usgs.gov/pub/data/gtopo30/global/%TEMPF2%
@pause
@if NOT EXIST %TEMPF2% goto NOTARGZ
:GOTTARZ
@echo Seem to have found %TEMPF2% ... will un-gzip it...
%TEMPGZIP% %TEMPGZIPD% %TEMPF2%
@if NOT EXIST %TEMPF1% goto NOTAR
:GOTTAR
@echo Got %TEMPF1% ...
%TEMPTAR% %TEMPTARX% %TEMPF1%
@if NOT EXIST %TEMPF3D% goto TARERR1
@if NOT EXIST %TEMPF3H% goto TARERR2

:GOTDEMRAW
@REM back out of DEMRAW folder...
@cd ..
@echo Got DEM RAW... need to convert to ASCII...
@if EXIST %TEMPD3%\%TEMPF3R% goto GOTASCII
@REM dir %TEMPD3%\%TEMPF3R%
@pause
@echo Got DEM RAW data ...
@if NOT EXIST %TEMPD3%\. mkdir %TEMPD3%
@if NOT EXIST %TEMPD3%\. goto ERR4
@echo Processing DEM RAW to ASCII ... moment...
%TEMPX1% %TEMPRANGE% %TEMPD2%\%TEMPF3% %TEMPD3%
@echo Done raw2ascii...
@if NOT EXIST %TEMPD3%\%TEMPF3R% goto FAILEDD2A

:GOTASCII
@REM appear to have ASCII DEM
@REM Exit data folder
@cd ..
@echo %CD%
@echo Got ASCII DEM files... ready for DEMCHOP
@if NOT EXIST %TEMPW1%\. goto CHKDC
@REM CARE WITH NAMING OF TEMPW2 - MUST MATCH genapts listing
@if NOT EXIST %TEMPW1%\%TEMPW2% goto CHKDC
@if EXIST %TEMPW1%\%TEMPW2%\%TEMPF3A%\%TEMPF3A%\. goto DONEDC
:CHKDC
@echo Can NOT locate %TEMPW1%\%TEMPW2% ... proceed to do demchop...
@pause
@if NOT EXIST %TEMPW1%\. mkdir %TEMPW1%
@if NOT EXIST %TEMPW1%\. goto ERR5
@cd %TEMPW1%
@if NOT EXIST %TEMPW2%\. mkdir %TEMPW2%
@if NOT EXIST %TEMPW2%\. goto ERR6
@cd ..
dir %TEMPD1%\%TEMPD3%\*.dem
@echo Process %TEMPD1%\%TEMPD3%\*.dem files...
@pause
@REM for %%i in (%TEMPD1%\%TEMPD3%\*.dem) do echo %%i %TEMPW1%\%TEMPW2%
@for %%i in (%TEMPD1%\%TEMPD3%\*.dem) do %TEMPX2% %%i %TEMPW1%\%TEMPW2%
:DONEDC
@echo Done DEMCHOP... appear to have arr.gz files... do terrafit?

dir /s %TEMPW1%\%TEMPW2%
@echo Check the files above... should be 500 or more... remember TOTAL
@echo DEMCHOP done... appear to have arr.gz files... do terrafit?
@echo There is no harm in running this multiple times... it skips existing files...
@pause

%TEMPX3% %TEMPW1%\%TEMPW2%
@echo Done terrafit ... should now have fit.gz files in %TEMPW1%\%TEMPW2
dir /s %TEMPW1%\%TEMPW2%
@echo In fact there should be one fit.gz for each arr.gz...
@echo Unless this is a re-run, there should now be DOUBLE the TOTAL given above... is it?
@pause

@REM MOVE ONTO AIRPORT DATA

@REM If already got the apt.dat file
@if EXIST %TEMPD1%\%TEMPAPT% goto GOTAPTDAT
@if EXIST %TEMPD1%\%TEMPAPT2% goto GOTAPTGZ
copy ..\%TEMPAPT3% %TEMPD1%\.
@if NOT EXIST %TEMPD1%\%TEMPAPT2% goto NOAPTDATZ
:GOTAPTGZ
@cd %TEMPD1%
%TEMPGZIP% %TEMPGZIPD% %TEMPAPT2%
@if NOT EXIST %TEMPAPT% goto NOAPTDAT
@cd ..
:GOTAPTDAT
@echo Have %TEMPAPT% file...
@if NOT EXIST %TEMPW1%\%TEMPW3%\. goto GENAPT
@if NOT EXIST %TEMPW1%\%TEMPW4%\. goto GENAPT
@echo Appear AIRPORTS have been generated. Delete %TEMPW3% or %TEMPW4% to redo...
dir /S %TEMPW1%\%TEMPW4%
@echo Appear AIRPORTS have been generated. Delete %TEMPW3% or %TEMPW4% to redo...
@goto DONEAPT
:GENAPT
@echo CWD=%CD%
@echo Can NOT locate %TEMPW1%\%TEMPW3% or %TEMPW1%\%TEMPW4% folders...
@echo Proceed to generate AIRPORTS ... from elevation data?
@echo This takes quite an amount of time to sift through the some nearly 30,000 airports,
@echo seeking those within the range -
@echo %TEMPRANGE%
@echo Be patient...
@pause
@REM genapts.exe --input=data\apt.dat --work=work --min-lon=150 --max-lon=154 --min-lat=-37 --max-lat=-30
%TEMPX4% --input=%TEMPD1%\%TEMPAPT% --work=%TEMPW1% %TEMPRANGE%
@if NOT EXIST %TEMPW1%\%TEMPW3%\. goto NOGENAPT
@if NOT EXIST %TEMPW1%\%TEMPW4%\. goto NOGENAPT

:DONEAPT

@echo Done airport generation ... continue with LAND USE generation
@pause

cd %TEMPW1%

@set TEMPVM2=LandMass
@set TEMPDIR=%TEMPVM2%\%TEMPCHUNK%
@if EXIST %TEMPDIR%\. goto DNVM1
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=Default %TEMPVMAP% %TEMPVM1% bnd polbnda
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM1
@set TEMPVML=%TEMPVM2%

@set TEMPVM2=Cities
@if EXIST %TEMPVM2%\. goto DNVM2
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=Urban %TEMPVMAP% %TEMPVM1% pop builtupa
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM2
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=Towns
@if EXIST %TEMPVM2%\. goto DNVM3
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=Town %TEMPVMAP% %TEMPVM1% pop mispopp
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM3
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=Crops
@if EXIST %TEMPVM2%\. goto DNVM4
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=MixedCropPastureCover %TEMPVMAP% %TEMPVM1% veg cropa
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM4
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=Forest
@if EXIST %TEMPVM2%\. goto DNVM5
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=MixedForestCover %TEMPVMAP% %TEMPVM1% veg treesa
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM5
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=Freeways
@if EXIST %TEMPVM2%\. goto DNVM6
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=Freeway --width=50m --att=med:1 %TEMPVMAP% %TEMPVM1% trans roadl
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM6
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=Roads
@if EXIST %TEMPVM2%\. goto DNVM7
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2%  --material=Road --width=20m --att=!med:1 %TEMPVMAP% %TEMPVM1% trans roadl
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM7
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=Railroads
@if EXIST %TEMPVM2%\. goto DNVM8
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=Railroad --width=10m %TEMPVMAP% %TEMPVM1% trans railrdl
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM8
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=Lakes
@if EXIST %TEMPVM2%\. goto DNVM9
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=Lake %TEMPVMAP% %TEMPVM1% hydro inwatera
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM9
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=PolarIce
@if EXIST %TEMPVM2%\. goto DNVM10
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=Glacier --att=f_code:BJ080 %TEMPVMAP% %TEMPVM1% phys seaicea
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM10
@set TEMPVML=%TEMPVML% %TEMPVM2%

@set TEMPVM2=Rivers
@if EXIST %TEMPVM2%\. goto DNVM11
%TEMPX5% %TEMPRANGE% --work-dir=%TEMPVM2% --material=Stream --width=100 %TEMPVMAP% %TEMPVM1% hydro watrcrsl
@if NOT EXIST %TEMPVM2%\. goto ERRVMAP
@%TEMPDBG%
:DNVM11
@set TEMPVML=%TEMPVML% %TEMPVM2%

@echo Done LIST..
@echo %TEMPVML%
@echo Continue with scenery construction?
@pause

cd %TEMPRET%

@REM TESTING EXISTANCE
@if NOT EXIST %TEMPX6% goto NOX6
@if NOT EXIST %TEMPD%\. goto NOTEST
@if NOT EXIST %TEMPD%\%TEMPW1%\. goto NOWORK
@if NOT EXIST %TEMPD%\%TEMPW1%\%TEMPW2%\. goto NOWORK2
@if NOT EXIST %TEMPD%\%TEMPW1%\%TEMPW3%\. goto NOWORK3
@if NOT EXIST %TEMPD%\%TEMPW1%\%TEMPW4%\. goto NOWORK4
@for %%i in (%TEMPVML%) do @(call :DOCHECK %%i)
@echo ......... *** Congratulations *** .......
@echo All tools and directories appears in order...

cd %TEMPD%
@if NOT EXIST %TEMPS1%\. mkdir %TEMPS1%
@if NOT EXIST %TEMPS1%\. goto NOS1
@if NOT EXIST %TEMPOUT%\. mkdir %TEMPOUT%
@if NOT EXIST %TEMPOUT%\. goto NOS2
@REM if NOT EXIST %TEMPS1%\%TEMPS2%\. mkdir %TEMPS1%\%TEMPS2%
@REM if NOT EXIST %TEMPS1%\%TEMPS2%\. goto NOS2
@if NOT EXIST %TEMPOUT%\%TEMPCHUNK%\. goto DOCONST
@echo Directory %TEMPOUT%\%TEMPCHUNK% already exists...
@echo Delete the %TEMPCHUNK% folder to redo scenery construction...
@goto DONESCENE

:DOCONST
@echo Continue? Note this can take a LONG time... be patient... Ctrl+C to abort (at any time)
@pause
@echo Doing construction ...

@REM fgfs-construct.exe --work-dir=./work --output-dir=./output --lon=55 --lat=60 --xdist=3 --ydist=3 \
@REM AirportArea SRTM-30 AirportObj Stream Bog IrrCropPastureCover Town Lake Urban Landmass Railroad \
@REM DryCropPastureCover Road EvergreenBroadCover Marsh Sand MixedCropPastureCover ScrubCover GrassCover \
@REM MixedForestCover

@REM --work-dir=work --output-dir=Scenery\Terrain --lon=154 --lat=-30 --xdist=4 --ydist=7 AirportArea SRTM-3 AirportObj LandMass Cities Towns Crops Forest Freeways Roads Railroads Lakes PolarIce Rivers
@echo Doing...
@echo --work-dir=%TEMPW1% --output-dir=%TEMPOUT% %TEMPCRNG% %TEMPW3% %TEMPW2% %TEMPW4% %TEMPVML%

%TEMPX6% --work-dir=%TEMPW1% --output-dir=%TEMPOUT% %TEMPCRNG% %TEMPW3% %TEMPW2% %TEMPW4% %TEMPVML%

@if NOT EXIST %TEMPOUT%\%TEMPCHUNK%\. goto NOCHUNK

:DONESCENE
@echo Done scenery construction in %TEMPOUT%\%TEMPCHUNK%
@echo Continue, and copy %TEMPW4% to the above, to fill in the Airport data?
@pause

@cd %TEMPOUT%\%TEMPCHUNK%
@echo Copying the Airport scenery into Terrain...
xcopy /S %TEMPRET%\%TEMPD%\%TEMPW1%\%TEMPW4%\%TEMPCHUNK%\*.* .
@echo All done ...
@echo.
@echo run Flightgear setting FG_SCENERY environment to, or using fg-scenery=
@echo fg-scenery=%TEMPRET%\%TEMPD%\%TEMPS1%
@echo.
@pause
@goto END

:DOCHECK
@set TEMPVM2=%1
@if "%TEMPVM2%x" == "x" goto :EOF
@if NOT EXIST %TEMPD%\%TEMPW1%\%TEMPVM2%\. goto NOVM2
@goto :EOF

:NOVM2
@echo ERROR: Can NOT locate %TEMPD%\%TEMPW1%\%TEMPVM2% directory...
@goto CHKFIX

:NOCHUNK
@echo ERROR: Directory %TEMPOUT%\%TEMPCHUNK% not created by fgfs-construct...
@echo Do not know the problem, but can only abort...
@goto ERREND

:NOWORK4
@echo ERROR: Can NOT locate %TEMPD%\%TEMPW1%\%TEMPW4% directory...
@goto CHKFIX

:NOWORK3
@echo ERROR: Can NOT locate %TEMPD%\%TEMPW1%\%TEMPW3% directory...
@goto CHKFIX

:NOWORK2
@echo ERROR: Can NOT locate %TEMPD%\%TEMPW1%\%TEMPW2% directory...
@goto CHKFIX

:NOWORK
@echo ERROR: Can NOT locate the %TEMPW1% directory...
@goto CHKFIX

:NOTEST
@echo ERROR: Can NOT locate the %TEMPD% directory...
@goto CHKFIX

:NOS1
@echo ERROR: FAILED to CREATE [%TEMPS1%] directory...
@goto ERRDIR

:NOS2
@echo ERROR: FAILED to CREATE [%TEMPS1%\%TEMPS2%] directory...
@goto ERRDIR

:ERRVMAP
@echo ERROR: tgvpf FAILED to create requested directory - %TEMPVM2%
@echo Have done %TEMPVML%
@goto ERREND

:NOGENAPT
@echo ERROR: genapts seems to have FAILED!
@echo CMD=%TEMPX4% --input=%TEMPD1%\%TEMPAPT% --work=%TEMPW1% %TEMPRANGE%
@goto ERREND

:NOAPTDAT
@echo ERROR: %TEMPGZIP% %TEMPGZIPD% %TEMPAPT2% appears to have failed!
@goto ERREND

:NOAPTDATZ
@echo ERROR: Copy of %TEMPAPT2% appears to have failed!
@goto ERREND


:FAILEDD2A
@echo ERROR: Can NOT locat %TEMPF3R% file. raw2ascii appears to have FAILED!
@goto ERREND


:TARERR1
@echo ERROR: After tar, can not locate %TEMPF3D% file...
@goto ERREND
:TARERR2
@echo ERROR: After tar, can not locate %TEMPF3H% file...
@goto ERREND

:NOTAR
@echo ERROR: Can not locate %TEMPF1%... aborting
@goto ERREND

:NOTARGZ
@echo ERROR: Appears download of %TEMPF2% FAILED! Can only exit...
@goto ERREND

:NOTGZIP
@echo ERROR: Can NOT seem to run 'gzip'...
@goto TOOLSDL

:NOTTAR
@echo ERROR: Can NOT seem to run 'tar'...
@goto TOOLSDL

:TOOLSDL
@echo WIN32 ports of the GNU Tools, tar ang zip can be found at
@echo http://unxutils.sourceforge.net/
@echo Or perhaps they are not in your PATH, or different version...
@goto ERREND

:ERR1
@echo ERROR: Can NOT create '%TEMPD%' directory!
@goto ERRDIR

:ERR2
@echo ERROR: Can NOT create '%TEMPD1%' directory!
@goto ERRDIR

:ERR3
@echo ERROR: Can NOT create '%TEMPD2%' directory!
@goto ERRDIR

:ERR4
@echo ERROR: Can NOT create '%TEMPD3%' directory!
@goto ERRDIR

:ERR5
@echo ERROR: Can NOT create '%TEMPW1%' directory!
@goto ERRDIR

:ERR6
@echo ERROR: Can NOT create '%TEMPW2%' directory!
@goto ERRDIR

:ERRDIR
@echo  Perhaps there is a file in the way... not writable media... unknown reason...
@goto ERREND

:NOX1
@echo ERROR: Can NOT locate the raw2ascii tool...
@echo %TEMPX1%
@goto CHKFIX

:NOX2
@echo ERROR: Can NOT locate the demchop tool...
@echo %TEMPX2%
@goto CHKFIX

:NOX3
@echo ERROR: Can NOT locate the terrafit tool...
@echo %TEMPX3%
@goto CHKFIX

:NOX4
@echo ERROR: Can NOT locate the genapts tool...
@echo %TEMPX4%
@goto CHKFIX

:NOX5
@echo ERROR: Can NOT locate the tgvpf tool...
@echo %TEMPX5%
@goto CHKFIX

:NOX6
@echo ERROR: Can NOT locate the fgfs-construct tool...
@echo %TEMPX6%
@goto CHKFIX

:NOAPT
@echo ERROR: Can NOT locate airport gz data file
@echo Seek %TEMPAPT2% file...
@goto CHKFIX

:NOVMAP
@echo ERROR: Can NOT locate the VMAP0 data
@echo NO folder [%TEMPVMAP%], or
@echo NO file [%TEMPVMAP%\%TEMPVM1%\lht]!
@goto CHKFIX

:CHKFIX
@echo Check name, location, and fix...
:ERREND
@echo Got critial ERROR. Aborting processing ...
:END
@cd %TEMPRET%
@endlocal
